<script setup lang="ts">
import type { UnitsTree } from "@/scripts/client-types";
import type { PropType } from "vue";
import { useRouter } from "vue-router";

const router = useRouter();

defineProps({
  node: {
    type: Object as PropType<UnitsTree>,
    required: true,
  },
});
</script>

<template>
  <li>
    <div
      @click="router.push(`/units/${node.code}`)"
      class="treeview_label inline-flex flex-col cursor-pointer border border-theme-background-darker hover:border-theme-accent min-w-[220px]"
    >
      <div class="flex items-center justify-center">
        <span class="w-[10%] border-b border-theme-background-darker"></span>
        <p class="text-theme-accent mx-3 text-xs">{{ node.code }}</p>
        <span class="w-[10%] border-b border-theme-background-darker"></span>
      </div>
      <span class="text-center text-sm">{{ node.display_name }}</span>
    </div>
    <ul>
      <UnitsTreeNode
        v-for="unit of node.sub_units"
        v-bind:key="unit.code"
        :node="unit"
      ></UnitsTreeNode>
    </ul>
  </li>
</template>

<style scoped lang="scss">
body {
  margin-bottom: 6em;
}

$border-color: #e3e5ef;
$primary-color: #bada55;

.treeview {
  $_treeview-level-size: 55px;

  ul {
    list-style: none;
    padding-left: 10px;

    li {
      padding: 25px 0px 0px 25px;
      position: relative;

      &:before {
        content: "";
        position: absolute;
        top: 0;
        left: 0;
        border-left: 2px solid #a2a5b5;
        width: 1px;
        height: 100%;
      }
      &:last-child:before {
        top: 0;
        height: 53px;
      }

      &:after {
        content: "";
        position: absolute;
        border-top: 3px dotted #a2a5b5;
        top: 50px;
        left: 3px;
        width: 22px;
      }
    }
  }
  // First Level Elements
  & > ul {
    & > li {
      &:after,
      &:last-child:before {
        content: unset;
      }

      &:before {
        top: 90px;
        left: 36px;
      }

      &:not(:last-child) > ul > li {
        &:before {
          content: unset;
        }
      }

      & > ul {
        padding-left: 10px;
      }
    }
  }
  // Treeview Components
  .treeview_label {
    padding: 5px 5px 5px 5px;
    border-radius: 5px;
    font-weight: 700;
    position: relative;
    z-index: 1;
  }
}
</style>
